UNIT Brw;

INTERFACE

Uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls, ExtCtrls, Menus, StdCtrls, Buttons, Registry, FileCtrl, ToolWin,
  ImgList,
  StopDlg, FiltDlg, TotalDlg, ExtrDlg, SelDlg, ColDlg, CompDlg, ParamDlg, VerFrm,
  ItemPro, FilePro, RegPro, AcsPro, TextPro, IniPro, GrpPro,
  PackPro, CompPro, SortPro, CRC,
  ViewPro, DetPro;

{--------------------------------------------------------------------------}

Type TCompareAction = (compare_act,
                       history_act,
                       contents_act,
                       difference_act,
                       evaluate_act,
                       lookup_act);

{--------------------------------------------------------------------------}

Type
  TBrowser = class (TForm)

    TreeView: TTreeView;
    Splitter: TSplitter;
    ListView: TListView;
    DetailSplitter: TSplitter;
    DetailView: TListView;

    StatusBar: TStatusBar;

    { etc }
    Images:      TImageList;
    StateImages: TImageList;

    OpenDialog:   TOpenDialog;
    SaveDialog:   TSaveDialog;
    ImportDialog: TOpenDialog;
    ExportDialog: TSaveDialog;

    PopupMenu:    TPopupMenu;

    { Menu }
    MainMenu: TMainMenu;

    MenuFile: TMenuItem;
    MenuEdit: TMenuItem;
    MenuView: TMenuItem;
    MenuSort: TMenuItem;
    MenuBlend: TMenuItem;
    MenuTools: TMenuItem;
    MenuDebug: TMenuItem;

    { file }
    MenuOpen: TMenuItem;
    MenuSave: TMenuItem;
    MenuImport: TMenuItem;
    MenuExport: TMenuItem;
    MenuFileSep1: TMenuItem;
    MenuDirectory: TMenuItem;
    MenuRegistry: TMenuItem;
    MenuIniFiles: TMenuItem;
    MenuGroups: TMenuItem;
    MenuFileSep2: TMenuItem;
    MenuExit: TMenuItem;

    { edit }
    MenuSelect: TMenuItem;
    MenuUnselect: TMenuItem;
    MenuSelectGroup: TMenuItem;
    MenuUnselectGroup: TMenuItem;
    MenuSelectAll: TMenuItem;
    MenuUnselectAll: TMenuItem;
    MenuEditSep1: TMenuItem;
    MenuFind: TMenuItem;
    MenuReplace: TMenuItem;
    MenuNext: TMenuItem;
    MenuExtract: TMenuItem;
    MenuEditSep2: TMenuItem;
    MenuDecolorizeBranch: TMenuItem;
    MenuDeleteBranch: TMenuItem;
    MenuDeleteTree: TMenuItem;

    { compare }
    MenuCompare: TMenuItem;
    MenuMark: TMenuItem;
    MenuCompareSep1: TMenuItem;
    MenuCompareCustom: TMenuItem;
    MenuCompareHistory: TMenuItem;
    MenuCompareContents: TMenuItem;
    MenuDifference: TMenuItem;
    MenuCompareSep2: TMenuItem;
    MenuEvaluate: TMenuItem;
    MenuLookup: TMenuItem;
    MenuDuplications: TMenuItem;

    { view }
    MenuViewStateImages: TMenuItem;
    MenuViewColumns: TMenuItem;
    MenuViewSummary: TMenuItem;
    ViewMenuSep: TMenuItem;
    MenuViewInfo: TMenuItem;
    MenuViewHistory: TMenuItem;
    MenuViewPermissions: TMenuItem;
    MenuViewVersion: TMenuItem;
    MenuViewNoDetails: TMenuItem;

    { sort }
    MenuSortByName: TMenuItem;
    MenuSortByExt: TMenuItem;
    MenuSortBySize: TMenuItem;
    MenuSortByTime: TMenuItem;
    MenuSortByValue: TMenuItem;
    MenuSortByColor: TMenuItem;
    MenuSortUnsorted: TMenuItem;

    { blend }
    MenuBlendNormal: TMenuItem;
    MenuBlendNew: TMenuItem;
    MenuBlendOld: TMenuItem;
    MenuBlendModified: TMenuItem;
    MenuBlendEqual: TMenuItem;
    MenuBlendSep1: TMenuItem;
    MenuBlendChecked: TMenuItem;
    MenuBlendPartial: TMenuItem;
    MenuBlendUnchecked: TMenuItem;
    MenuBlendSep2: TMenuItem;
    MenuBlendDirectories: TMenuItem;
    MenuBlendFiles: TMenuItem;
    MenuTotalSize: TMenuItem;
    MenuVersionTable: TMenuItem;
    MenuToolsSep1: TMenuItem;
    MenuCalculateCRC: TMenuItem;
    MenuScanPermissions: TMenuItem;
    MenuToolsSep2: TMenuItem;
    MenuSaveOptions: TMenuItem;
    MenuRestoreOptions: TMenuItem;

    { debug }
    MenuMemory: TMenuItem;
    MenuTimeFormat: TMenuItem;
    MenuDebugSep: TMenuItem;
    MenuLoad: TMenuItem;
    MenuStore: TMenuItem;

    { toolbar }
    ToolBar: TToolBar;

    ToolGoUp: TToolButton;
    ToolSep1: TToolButton;
    ToolStateImages: TToolButton;
    ToolSep2: TToolButton;
    ToolSortByColor: TToolButton;
    ToolSep3: TToolButton;
    ToolBlendNormal: TToolButton;
    ToolBlendNew: TToolButton;
    ToolBlendOld: TToolButton;
    ToolBlendModified: TToolButton;
    ToolBlendEqual: TToolButton;
    ToolSep4: TToolButton;
    ToolBlendChecked: TToolButton;
    ToolBlendPartial: TToolButton;
    ToolBlendUnchecked: TToolButton;
    ToolSep5: TToolButton;
    ToolBlendDirectories: TToolButton;
    ToolBlendFiles: TToolButton;
    { checkpoint }

    { popup menu }
    procedure PopupMenuPopup (Sender: TObject);

    { file }
    procedure MenuOpenClick        (Sender: TObject);
    procedure MenuSaveClick        (Sender: TObject);
    procedure MenuImportClick      (Sender: TObject);
    procedure MenuExportClick      (Sender: TObject);
    procedure MenuDirectoryClick   (Sender: TObject);
    procedure MenuRegistryClick    (Sender: TObject);
    procedure MenuPermissionsClick (Sender: TObject);
    procedure MenuIniFilesClick    (Sender: TObject);
    procedure MenuGroupsClick      (Sender: TObject);
    procedure MenuExitClick        (Sender: TObject);

    { edit }
    procedure MenuSelectClick           (Sender: TObject);
    procedure MenuUnselectClick         (Sender: TObject);
    procedure MenuSelectGroupClick      (Sender: TObject);
    procedure MenuUnselectGroupClick    (Sender: TObject);
    procedure MenuSelectAllClick        (Sender: TObject);
    procedure MenuUnselectAllClick      (Sender: TObject);
    procedure MenuExtractClick          (Sender: TObject);
    procedure MenuDecolorizeBranchClick (Sender: TObject);
    procedure MenuDeleteBranchClick     (Sender: TObject);
    procedure MenuDeleteTreeClick       (Sender: TObject);

    { compare }
    procedure MenuMarkClick            (Sender: TObject);
    procedure MenuCompareCustomClick   (Sender: TObject);
    procedure MenuCompareContentsClick (Sender: TObject);
    procedure MenuCompareHistoryClick  (Sender: TObject);
    procedure MenuDifferenceClick      (Sender: TObject);
    procedure MenuEvaluateClick        (Sender: TObject);
    procedure MenuLookupClick          (Sender: TObject);
    procedure MenuDuplicationsClick    (Sender: TObject);

    { view }
    procedure MenuViewClick (Sender: TObject);

    { sort }
    procedure MenuSortClick (Sender: TObject);

    { blend }
    procedure MenuBlendClick   (Sender: TObject);

    { tools }
    procedure MenuToolsClick          (Sender: TObject);
    procedure MenuTotalSizeClick      (Sender: TObject);
    procedure MenuVersionTableClick   (Sender: TObject);
    procedure MenuCalculateCRCClick   (Sender: TObject);
    procedure MenuSaveOptionsClick    (Sender: TObject);
    procedure MenuRestoreOptionsClick (Sender: TObject);

    { debug }
    procedure MenuMemoryClick     (Sender: TObject);
    procedure MenuTimeFormatClick (Sender: TObject);
    procedure MenuLoadClick       (Sender: TObject);
    procedure MenuStoreClick      (Sender: TObject);

    { init }
    procedure FormCreate (Sender: TObject);
    { checkpoint }

  private
    CustomConfig: TCompareOpt; { parametry pro porovnavani }

    { add branch }
    procedure AddBranch (item: TItem);

    { state }
    procedure SelectGroup (sel: TState; mask: string; sub: boolean);

    { crc }
    procedure CalculateCRC (item: TItem);

    { decolorize }
    procedure DecolorizeBranch (item: TItem);

    { move up / down }
    function  TopLevel (item: TItem): boolean;

    { compare }
    procedure ExecCompare (act: TCompareAction);

  public
    view:   TView;
    detail: TDetail;
    mark:   TItem;

    { status bar }
    procedure Status (txt: string);
  end;

Var
  Browser: TBrowser;

IMPLEMENTATION

{$R *.DFM}

(********************************* ERROR **********************************)

Procedure Error (s: string);
Begin
     raise Exception.Create (s);
End;

(******************************* STATUS BAR *******************************)

Procedure TBrowser.Status (txt: string);
Begin
     StatusBar.SimpleText := txt;
     StatusBar.Update;
End;

(******************************* ADD BRANCH *******************************)

Procedure TBrowser.AddBranch (item: TItem);
Begin
     view.AddBranch (item);
End;

(******************************* POPUP MENU *******************************)

Procedure TBrowser.PopupMenuPopup (Sender: TObject);
Var  i: integer;
     { src, dst: TMenuItem; }
Begin
     { MenuInfoClick (nil); }

     for i := PopupMenu.Items.Count-1 downto 0 do
        PopupMenu.Items.Delete (i);

     {
     for i := 0 to MenuInfo.Count-1 do begin
        src := MenuInfo [i];
        if src.Caption = '-' then break;
        if src.Enabled and (src.Caption <> '-') then begin
           dst := TMenuItem.Create (PopupMenu);
           dst.Caption := src.Caption;
           dst.GroupIndex := 100;
           dst.OnClick := src.OnClick;
           PopupMenu.Items.Add (dst);
        end;
     end;
     }
End;

(******************************* FILE MENU ********************************)

Procedure TBrowser.MenuOpenClick (Sender: TObject);
Var  ans: TItem;
Begin
     if OpenDialog.Execute then begin
        OpenDialog.InitialDir := '';
        ans := LoadCtl (OpenDialog.FileName);
        if ans <> nil then view.ChangeTree (ans);
     end;
End;

Procedure TBrowser.MenuSaveClick (Sender: TObject);
Begin
     if SaveDialog.Execute then begin
        SaveDialog.InitialDir := '';
        SaveCtl (SaveDialog.FileName, view.root);
     end;
End;

Procedure TBrowser.MenuImportClick (Sender: TObject);
Var  fname: string;
     ans: tItem;
Begin
     if ImportDialog.Execute then begin
        fname := ImportDialog.FileName;
        ImportDialog.InitialDir := '';
        ans := nil;

        case ImportDialog.FilterIndex of
           1: ans := LoadCtl (fname);
           2: ans := LoadDir (fname);
           3: ans := LoadReg (fname);

           4: ans := ScanCab (fname);
           5: ans := ScanPak (fname);
           6: ans := ScanIComp (fname);

           7: ans := ScanArc (fname);
           8: ans := ScanArj (fname);
           9: ans := ScanLzh (fname);
          10: ans := ScanZip (fname);
        end;

        if ans <> nil then begin
           if ans.pict = tree_pict then
              ans.pict := box_pict;
           AddBranch (ans);
        end;
     end;
End;

Procedure TBrowser.MenuExportClick (Sender: TObject);
Var  item:  TItem;
     fname: string;
Begin
     item := view.CurrentTreeItem;
     if (item <> nil) and item.folder then
        if ExportDialog.Execute then begin
           fname := ExportDialog.FileName;
           ExportDialog.InitialDir := '';

           case ExportDialog.FilterIndex of
              1: SaveCtl (fname, item);
              2: SaveReg (fname, item);
           end;
        end;
End;

{--------------------------------------------------------------------------}

Function WindowsDir: string;
Const max = MAX_PATH;
Var   buf: array [0..max-1] of char;
Begin
     GetWindowsDirectory (buf, max);
     result := buf;
End;

Function SelectDir (var fname: string): boolean;
Begin
     result := SelectDirectory ('Select Directory', '', fname);
End;

{--------------------------------------------------------------------------}

Procedure TBrowser.MenuDirectoryClick (Sender: TObject);
Var  fname: string;
Begin
     if SelectDir (fname) then
        AddBranch (ScanDir (fname));
End;

Procedure TBrowser.MenuRegistryClick (Sender: TObject);
Begin
     AddBranch (ScanReg (''));
End;

Procedure TBrowser.MenuPermissionsClick (Sender: TObject);
Var  fname: string;
Begin
     if SelectDir (fname) then
        AddBranch (ScanPermissions (fname));
End;

Procedure TBrowser.MenuIniFilesClick (Sender: TObject);
Var  fname: string;
Begin
     if SelectDir (fname) then
        AddBranch (ScanIni (fname));
End;

Procedure TBrowser.MenuGroupsClick (Sender: TObject);
Begin
     AddBranch (ScanGrp);
End;

{--------------------------------------------------------------------------}

Procedure TBrowser.MenuExitClick (Sender: TObject);
Begin
     Close;
End;

(******************************* EDIT MENU ********************************)

Procedure TBrowser.MenuSelectClick (Sender: TObject);
Begin
     view.SelectCmd;
End;

Procedure TBrowser.MenuUnselectClick (Sender: TObject);
Begin
     view.UnselectCmd;
End;

Procedure TBrowser.SelectGroup (sel: TState; mask: string; sub: boolean);
Begin
     BeginWait ('Selecting');
     try
        view.SelGroup (view.main, sel, mask, sub);
     finally
        EndWait;
     end;
End;

Procedure TBrowser.MenuSelectGroupClick (Sender: TObject);
Begin
     with SelectDialog do
        if Execute (true) then
           SelectGroup (checked, mask, subdir);
End;

Procedure TBrowser.MenuUnselectGroupClick (Sender: TObject);
Begin
     with SelectDialog do
        if Execute (false) then
           SelectGroup (unchecked, mask, subdir);
End;

Procedure TBrowser.MenuSelectAllClick (Sender: TObject);
Begin
     SelectGroup (checked, '*', true);
End;

Procedure TBrowser.MenuUnselectAllClick (Sender: TObject);
Begin
     SelectGroup (unchecked, '*', true);
End;

{-------------------------------- EXTRACT ---------------------------------}

Function ExtractItem (item: TItem; ok: boolean): TItem;
Begin
     result := Duplicate (item);
     result.mode := item.mode;
     result.state := item.state;
End;

Function ExtractBranch (item: TItem; level: integer): TItem;
Var  ok: boolean;
     p, t: TItem;
Begin
     result := nil;

     ok := (item.mode in ExtractDialog.modes) and
           (item.state in ExtractDialog.states);

     if (level = 1) and ExtractDialog.ThisDir then ok := false;

     if ok then result := ExtractItem (item, true);

     { sub items }
     if ExtractDialog.SubDir then begin
        p := item.sub.first;
        while p <> nil do begin
           t := ExtractBranch (p, level+1);
           if t <> nil then begin
              if result = nil then result := ExtractItem (item, false);
              result.Add (t);
           end;
           p := p.next;
        end;
     end;
End;

Procedure TBrowser.MenuExtractClick (Sender: TObject);
Var  item, new_item: TItem;
Begin
     item := view.CurrentTreeItem;
     if ExtractDialog.Execute then begin
        new_item := ExtractBranch (item, 1);
        if new_item <> nil then AddBranch (new_item)
                           else ShowMessage ('No item extracted');
     end;
End;

{--------------------------- DECOLORIZE BRANCH ----------------------------}

Procedure TBrowser.DecolorizeBranch (item: TItem);
Var  p: TItem;
Begin
     item.mode := normal;
     p := item.sub.first;
     while p <> nil do begin
        p.mode := normal;
        if p.folder then DecolorizeBranch (p)
                    else p.mode := normal;
        p := p.next;
     end;
End;

Procedure TBrowser.MenuDecolorizeBranchClick (Sender: TObject);
Var  item: TItem;
Begin
     item := view.CurrentTreeItem;
     if item <> nil then begin
        DecolorizeBranch (item);
        view.UpdateBranch (item);
        view.ChangeList (view.main);
     end;
End;

{-------------------------- DELETE BRANCH / TREE --------------------------}

Function TBrowser.TopLevel (item: TItem): boolean;
Begin
     result := (item <> nil) and (item.up = view.root);
End;

Procedure TBrowser.MenuDeleteBranchClick (Sender: TObject);
Var  item: TItem;
     ans:  word;
Begin
     item := view.CurrentItem;
     if TopLevel (item) then begin
        ans := MessageDlg ('Delete tree branch ?',
                           mtConfirmation, [mbYes, mbNo], 0);
        if ans = mrYes then
           view.DeleteBranch (item);
     end;
End;

Procedure TBrowser.MenuDeleteTreeClick (Sender: TObject);
Var  ans: word;
Begin
     ans := MessageDlg ('Delete tree ?',
                        mtConfirmation, [mbYes, mbNo], 0);
     if ans = mrYes then
        view.ChangeTree (NewRoot);
End;

(****************************** COMPARE MENU ******************************)

Procedure TBrowser.ExecCompare (act: TCompareAction);
Const no_dialog = [history_act, contents_act, difference_act];
      update_branch = [evaluate_act, lookup_act];
Var   src, dst, ans: TItem;
      cont: boolean;
Begin
     src := mark;
     dst := view.CurrentTreeItem;

     if (src <> nil) and (dst <> nil) then begin
        { dialog box }
        cont := true;
        if not (act in no_dialog) then
           cont := CompareDialog.Execute (CustomConfig);

        if cont then begin
           StopOpen ('Comparing');
           ans := nil;

           { compare }
           case act of
              compare_act:    ans := Compare (src, dst, CustomConfig);
              history_act:    ans := Compare (src, dst, CompareHistoryConfig);
              contents_act:   ans := Compare (src, dst, CompareContentsConfig);
              difference_act: ans := Compare (src, dst, DifferenceConfig);
              evaluate_act:   Evaluate (src, dst, CustomConfig);
              lookup_act:     Lookup (src, dst, CustomConfig);
           end;

           { add new branch }
           if ans <> nil then AddBranch (ans);

           { update branch }
           if act in update_branch then begin
              view.UpdateBranch (dst);
              view.ChangeList (view.main);
           end;

           StopClose;
        end;
     end;
End;

{--------------------------------------------------------------------------}

Procedure TBrowser.MenuMarkClick (Sender: TObject);
Begin
     mark := view.CurrentItem;
End;

Procedure TBrowser.MenuCompareCustomClick (Sender: TObject);
Begin
     ExecCompare (compare_act);
End;

Procedure TBrowser.MenuCompareHistoryClick (Sender: TObject);
Begin
     ExecCompare (history_act);
End;

Procedure TBrowser.MenuCompareContentsClick (Sender: TObject);
Begin
     ExecCompare (contents_act);
End;

Procedure TBrowser.MenuDifferenceClick (Sender: TObject);
Begin
     ExecCompare (difference_act);
End;

Procedure TBrowser.MenuEvaluateClick (Sender: TObject);
Begin
     ExecCompare (evaluate_act);
End;

Procedure TBrowser.MenuLookupClick (Sender: TObject);
Begin
     ExecCompare (lookup_act);
End;

Procedure TBrowser.MenuDuplicationsClick (Sender: TObject);
Var  src: TItem;
Begin
     src := view.CurrentTreeItem;

     if src <> nil then
        if CompareDialog.Execute (CustomConfig) then begin
           StopOpen ('Comparing');
           AddBranch (FindDuplications (src, CustomConfig));
           StopClose;
        end;
End;

(******************************* VIEW MENU ********************************)

Procedure TBrowser.MenuViewClick (Sender: TObject);
Begin
     detail.UpdateViewMenu;
End;

(******************************* SORT MENU ********************************)

Procedure TBrowser.MenuSortClick (Sender: TObject);
Begin
     view.UpdateSortMenu;
End;

(******************************* BLEND MENU *******************************)

Procedure TBrowser.MenuBlendClick (Sender: TObject);
Begin
     view.UpdateBlendMenu;
End;

(******************************* TOOLS MENU *******************************)

Procedure TBrowser.MenuToolsClick (Sender: TObject);
Begin
     MenuTotalSize.Enabled       := true;
     MenuVersionTable.Enabled    := view.main is TFileItem;
     MenuCalculateCRC.Enabled    := view.main is TFileItem;
     MenuScanPermissions.Enabled := view.main is TFileItem;
     MenuVersionTable.Enabled    := view.main is TFileItem;
End;

Procedure TBrowser.MenuTotalSizeClick (Sender: TObject);
Begin
     TotalDialog.ShowModal;
End;

Procedure TBrowser.MenuVersionTableClick (Sender: TObject);
Var  item: TItem;
Begin
     item := view.main;
     if item is TFileItem then
        VersionTable (item as TFileItem);
End;

{---------------------------------- CRC -----------------------------------}

Procedure TBrowser.CalculateCRC (item: TItem);
Var  p: TItem;
Begin
     if item <> nil then begin
        p := item.sub.first;
        while (p <> nil) and not StopFlag do begin
           p.GetCRC;
           if p.folder then CalculateCRC (p);
           p := p.next;
        end;
     end;
End;

Procedure TBrowser.MenuCalculateCRCClick (Sender: TObject);
Begin
     StopOpen ('Calculating CRC');
     try
        CalculateCRC (view.main);
     finally
        StopClose;
     end;
     view.ChangeList (view.main);
End;

{------------------------- SAVE / RESTORE OPTIONS -------------------------}

Procedure TBrowser.MenuSaveOptionsClick (Sender: TObject);
Var  reg: TRegIniFile;
Begin
     reg := TRegIniFile.Create ('Software\ZC\Elm');
     reg.WriteBool ('', 'State Images', view.state_images);
     reg.Free;
End;

Procedure TBrowser.MenuRestoreOptionsClick (Sender: TObject);
Var  reg: TRegIniFile;
     val: boolean;
Begin
     reg := TRegIniFile.Create ('Software\ZC\Elm');
     val := reg.ReadBool ('', 'State Images', false);
     reg.Free;

     view.SetStateImages (val);
End;

(******************************* DEBUG MENU *******************************)

Procedure TBrowser.MenuMemoryClick (Sender: TObject);
Var  HS: THeapStatus;
Begin
     HS := GetHeapStatus;
     if HS.HeapErrorCode <> 0 then Error ('Corrupted heap');

     with ParamDialog do begin
        Init   ('Memory');
        AddNum ('ItemCount', ItemCount);
        AddNum ('ItemSize',  ItemSize);
        Add    ('', '');

        AddNum ('TotalAddrSpace',   HS.TotalAddrSpace);
        AddNum ('TotalUncommitted', HS.TotalUncommitted);
        AddNum ('TotalCommitted',   HS.TotalCommitted);
        AddNum ('TotalAllocated',   HS.TotalAllocated);
        AddNum ('TotalFree',        HS.TotalFree);
        AddNum ('FreeSmall',        HS.FreeSmall);
        AddNum ('FreeBig',          HS.FreeBig);
        AddNum ('Unused',           HS.Unused);
        AddNum ('Overhead',         HS.Overhead);
        AddNum ('HeapErrorCode',    HS.HeapErrorCode);

        Run;
     end;
End;

{------------------------------ TIME FORMAT -------------------------------}

Procedure TBrowser.MenuTimeFormatClick (Sender: TObject);
Var  LocaleID: LCID;
     txt: string;
Begin
     txt := 'Current date and time format is  ' +
            ShortDateFormat + '  ' + ShortTimeFormat;

     LocaleID := GetSystemDefaultLCID;
     txt := txt + ^M + 'System date and time format is  ' +
            GetLocaleStr (LocaleID, LOCALE_SSHORTDATE, '?') + '  ' +
            GetLocaleStr (LocaleID, LOCALE_STIMEFORMAT, '?') ;

     LocaleID := GetUserDefaultLCID;
     txt := txt + ^M + 'User date and time format is      ' +
            GetLocaleStr (LocaleID, LOCALE_SSHORTDATE, '?') + '  ' +
            GetLocaleStr (LocaleID, LOCALE_STIMEFORMAT, '?') ;

     txt := txt + ^M + 'ANSI code page is ' +
            IntToStr (GetACP);

     txt := txt + ^M + 'OEM code page is ' +
            IntToStr (GetOEMCP);

     ShowMessage (txt);
End;

{------------------------------ LOAD / STORE ------------------------------}

Procedure TBrowser.MenuLoadClick (Sender: TObject);
// Var  item: TItem;
Begin
     // AddBranch (ScanPermissions ('f:\winnt\profiles\Zdenek'));
     // TAcsThread.Create (root, 'f:\winnt\profiles', queue);
     // TAcsThread.Create (view.root, 'f:\winnt', queue);

     // AddBranch (ScanDir ('n:\HomeSite4'));
     // AddBranch (ScanDir ('n:\IBM'));
     // TCrcThread.Create (main, queue);

     // AddBranch (ScanDir ('f:\winnt'));
     // AddBranch (ScanReg ('\\PII'));

     // AddBranch (LoadCtl ('c:\temp\m-ins.ctl'));
     // AddBranch (LoadCtl ('c:\temp\m-os.ctl'));

     // AddBranch (ScanIComp ('c:\data\arc\ishield.z'));
     // AddBranch (ScanZip ('c:\data\arc\owl.zip'));

     // AddBranch (ScanDir ('c:\win95'));
     // MenuVersionTable.Click;

     {
     item := LoadReg ('c:\temp\ntb9.reg');
     item.name := '';
     SaveReg ('C:\temp\list.reg', item);
     AddBranch (item);
     }

     AddBranch (ScanDir ('f:\borland\Delphi4'));
     MenuViewSummary.OnClick (nil);
End;

Procedure TBrowser.MenuStoreClick (Sender: TObject);
Begin
     StopOpen ('Scannig');
     try
        AddBranch (ScanDir (ExtractFileDrive (WindowsDir)+'\'));
        if not StopFlag then AddBranch (ScanReg (''));
        if not StopFlag then AddBranch (ScanIni (WindowsDir));
        if not StopFlag then AddBranch (ScanGrp);
     finally
        StopClose;
     end;
     if not StopFlag then MenuSaveClick (Sender);
End;

(******************************* INIT, ... ********************************)

Procedure GetUserFormatSettings;
Var  HourFormat, TimePostfix: string;
     locale: LCID;
Begin
     locale := GetUserDefaultLCID;
     CurrencyString := GetLocaleStr (locale, LOCALE_SCURRENCY, '');
     CurrencyFormat := StrToIntDef (GetLocaleStr (locale, LOCALE_ICURRENCY, '0'), 0);
     NegCurrFormat := StrToIntDef (GetLocaleStr (locale, LOCALE_INEGCURR, '0'), 0);
     ThousandSeparator := GetLocaleChar (locale, LOCALE_STHOUSAND, ',');
     DecimalSeparator := GetLocaleChar (locale, LOCALE_SDECIMAL, '.');
     CurrencyDecimals := StrToIntDef (GetLocaleStr (locale, LOCALE_ICURRDIGITS, '0'), 0);
     DateSeparator := GetLocaleChar (locale, LOCALE_SDATE, '/');
     ShortDateFormat := GetLocaleStr (locale, LOCALE_SSHORTDATE, 'm/d/yy');
     LongDateFormat := GetLocaleStr (locale, LOCALE_SLONGDATE, 'mmmm d, yyyy');
     TimeSeparator := GetLocaleChar (locale, LOCALE_STIME, ':');
     TimeAMString := GetLocaleStr (locale, LOCALE_S1159, 'am');
     TimePMString := GetLocaleStr (locale, LOCALE_S2359, 'pm');
     if StrToIntDef (GetLocaleStr (locale, LOCALE_ITLZERO, '0'), 0) = 0
        then HourFormat := 'h'
        else HourFormat := 'hh';
     if StrToIntDef (GetLocaleStr (locale, LOCALE_ITIME, '0'), 0) = 0
        then TimePostfix := ' AMPM'
        else TimePostfix := '';
     HourFormat := 'hh'; { important }
     ShortDateFormat := 'dd/mm/yy';  { important }
     ShortTimeFormat := HourFormat + ':mm' + TimePostfix;
     LongTimeFormat := HourFormat + ':mm:ss' + TimePostfix;
End;

Procedure TBrowser.FormCreate (Sender: TObject);
Begin
     { view }
     view := TView.Create;

     view.TreeView    := TreeView;
     view.ListView    := ListView;
     view.StateImages := StateImages;

     view.MenuViewStateImages  := MenuViewStateImages;
     view.MenuViewColumns      := MenuViewColumns;
     view.MenuViewSummary      := MenuViewSummary;

     view.MenuSortByName       := MenuSortByName;
     view.MenuSortByExt        := MenuSortByExt;
     view.MenuSortBySize       := MenuSortBySize;
     view.MenuSortByTime       := MenuSortByTime;
     view.MenuSortByValue      := MenuSortByValue;
     view.MenuSortByColor      := MenuSortByColor;
     view.MenuSortUnsorted     := MenuSortUnsorted;

     view.MenuBlendNormal      := MenuBlendNormal;
     view.MenuBlendNew         := MenuBlendNew;
     view.MenuBlendOld         := MenuBlendOld;
     view.MenuBlendModified    := MenuBlendModified;
     view.MenuBlendEqual       := MenuBlendEqual;
     view.MenuBlendChecked     := MenuBlendChecked;
     view.MenuBlendPartial     := MenuBlendPartial;
     view.MenuBlendUnchecked   := MenuBlendUnchecked;
     view.MenuBlendDirectories := MenuBlendDirectories;
     view.MenuBlendFiles       := MenuBlendFiles;

     view.ToolGoUp             := ToolGoUp;
     view.ToolStateImages      := ToolStateImages;
     view.ToolSortByColor      := ToolSortByColor;

     view.ToolBlendNormal      := ToolBlendNormal;
     view.ToolBlendNew         := ToolBlendNew;
     view.ToolBlendOld         := ToolBlendOld;
     view.ToolBlendModified    := ToolBlendModified;
     view.ToolBlendEqual       := ToolBlendEqual;
     view.ToolBlendChecked     := ToolBlendChecked;
     view.ToolBlendPartial     := ToolBlendPartial;
     view.ToolBlendUnchecked   := ToolBlendUnchecked;
     view.ToolBlendDirectories := ToolBlendDirectories;
     view.ToolBlendFiles       := ToolBlendFiles;

     view.Setup;

     { detail }
     detail := TDetail.Create;

     detail.View           := view;
     detail.DetailSplitter := DetailSplitter;
     detail.DetailView     := DetailView;
     detail.Images         := Images;

     detail.MenuViewInfo        := MenuViewInfo;
     detail.MenuViewHistory     := MenuViewHistory;
     detail.MenuViewPermissions := MenuViewPermissions;
     detail.MenuViewVersion     := MenuViewVersion;
     detail.MenuViewNoDetails   := MenuViewNoDetails;

     detail.Setup;

     CustomConfig := CompareHistoryConfig;
     GetUserFormatSettings;

     // MenuSelectGroup.ShortCut   := ShortCut (VK_ADD, []);
     // MenuUnselectGroup.ShortCut := ShortCut (VK_SUBTRACT, []);

     // MenuMoveUp.ShortCut   := ShortCut (VK_UP, [ssCtrl]);
     // MenuMoveDown.ShortCut := ShortCut (VK_DOWN, [ssCtrl]);

     view.ChangeTree (NewRoot);
End;

END.

