UNIT Other;

INTERFACE

Type
  Abc = class

    { enable controls }
    procedure SetControls (val: boolean);

    { queue }
    procedure AddItem (top, item: TItem);
    procedure SetItemMode (item: TItem; val: TMode);
    procedure CheckMode (item: TItem; go_up: boolean);
    procedure UpdateItem (item: TItem);
    procedure IdleProc (Sender: TObject; var Done: Boolean);

    { test }
    {
    procedure TestBranch (item: TItem);
    procedure Test;
    }

    end;

IMPLEMENTATION

Procedure TBrowser.SetControls (val: boolean);
Var  i: integer;
Begin
     ToolBar.Enabled   := val;
     TreeView.Enabled  := val;
     ListView.Enabled  := val;
     Splitter.Enabled  := val;
     StatusBar.Enabled := val;

     for i := 0 to MainMenu.Items.Count-1 do
        MainMenu.Items[i].Enabled := val;
End;

(********************************** LOAD **********************************)

Procedure TBrowser.MenuLoadClick (Sender: TObject);
Begin
     // AddBranch (ScanPermissions ('f:\winnt\profiles\Zdenek'));
     // TAcsThread.Create (root, 'f:\winnt\profiles', queue);
     TAcsThread.Create (view.root, 'f:\winnt', queue);

     // AddBranch (ScanDir ('n:\HomeSite4'));
     // AddBranch (ScanDir ('n:\IBM'));
     // TCrcThread.Create (main, queue);

     // AddBranch (ScanDir ('f:\winnt'));
     // AddBranch (ScanReg ('\\PII'));

     // AddBranch (LoadCtl ('c:\temp\m-ins.ctl'));
     // AddBranch (LoadCtl ('c:\temp\m-os.ctl'));

     // AddBranch (ScanIComp ('c:\data\arc\ishield.z'));
     // AddBranch (ScanZip ('c:\data\arc\owl.zip'));

     // AddBranch (ScanDir ('c:\win95'));
     // MenuVersionTable.Click;
End;

(********************************* QUEUE **********************************)

Procedure TBrowser.AddItem (top, item: TItem);
Begin
     Assert (top <> nil);
     Assert (item <> nil);

     // SortFolder (item, SortFunc (ByName), true);
     top.Add (item);

     // TreeView.Items.BeginUpdate;
     if top.ref <> nil then
        view.AddToTree (item);
     // TreeView.Items.EndUpdate;
End;

{--------------------------------------------------------------------------}

Procedure TBrowser.SetItemMode (item: TItem; val: TMode);
Begin
     { set value }
     item.mode := val;

     { update tree view }
     if item.ref <> nil then begin
        item.ref.ImageIndex    := item.GetImageIndex (false);
        item.ref.SelectedIndex := item.GetImageIndex (true);
     end;

     { update list view }
     if item.lst >= 0 then
        ListView.UpdateItems (item.lst, item.lst);
End;

Procedure TBrowser.CheckMode (item: TItem; go_up: boolean);
{ Uprav nadrazene prvky }
Var  p: TItem;
     eq: boolean;
     ans: TMode;
Begin
     if item <> nil then begin

        p := item.sub.first;
        if p <> nil then begin
           { item ma alespon jeden vnoreny prvek }

           { prvni prvek }
           ans := p.mode;
           eq := true;
           p := p.next;

           { dalsi prvky }
           while (p <> nil) and eq do begin
              if p.mode <> ans then eq := false;
              p := p.next;
           end;

           { vysledek }
           if not eq then ans := modified;
           if item.mode <> ans then begin
              SetItemMode (item, ans); { oprav stav }
              if go_up then CheckMode (item.up, true); { pokracuj nahoru }
           end;

        end;
     end;
End;

Procedure TBrowser.UpdateItem (item: TItem);
Begin
     Assert (item <> nil);

     SetItemMode (item, new);
     CheckMode (item.up, true);
End;

{--------------------------------------------------------------------------}

Procedure TBrowser.IdleProc (Sender: TObject; var Done: Boolean);
Var  e: TElement;
     n: integer;
Begin
     if queue.Ready then begin
        TreeView.Items.BeginUpdate;
        n := 0;
        while queue.Ready and (n <= 100) do begin
           queue.Recall (e);
           case e.kind of
              add_item:    AddItem (e.par1, e.par2);
              update_item: UpdateItem (e.par1);
              else         Error ('Unknown element kind');
           end;
           inc (n);
        end;
        TreeView.Items.EndUpdate;
        Status ('Element ' + IntToStr (e.num) + ', Ready ' + IntToStr (queue.ReadyCount));
     end;
End;

(********************************** TEST **********************************)

(*
Procedure FindName (item: TRegItem; var ans: TMode);
Var  p: TRegItem;
     cnt: integer;
     tmp: TMode;
Begin
     if item.folder then begin
        p := item.sub.first as TRegItem;
        ans := equal;
        cnt := 0;
        while p <> nil do begin
           FindName (p, tmp);
           inc (cnt);
           if cnt = 1 then ans := tmp
           else if ans <> tmp then ans := modified;
           p := p.next as TRegItem;
        end;
     end
     else begin
        if (item.kind = REG_SZ) and (Pos (':\', item.value) <> 0)
           then ans := new
           else ans := equal;
     end;
     item.mode := ans;
End;

Procedure FindNames;
Var  item: TItem;
     ans: TMode;
Begin
     item := Browser.CurrentTreeItem;
     if item is TRegItem then begin
        FindName (item as TRegItem, ans);
        Browser.UpdateBranch (item);
     end;
End;
*)

{--------------------------------------------------------------------------}

(*
{ zaskrtni shodne soubory }

Procedure TBrowser.TestBranch (item: TItem);
Var  p: TItem;
Begin
     p := item.sub.first;
     while p <> nil do begin
        if p.mode = equal then SetItemState (p, checked);

        if p.folder then TestBranch (p);
        p := p.next;
     end;
     CheckState (item, false);
End;

Procedure TBrowser.Test;
Var  item: TItem;
Begin
     item := Browser.CurrentTreeItem;
     TestBranch (item);
     CheckState (item, true);
     Browser.UpdateBranch (item);
End;
*)

END.
