UNIT ParamDlg;

INTERFACE

Uses
  Windows, Messages, SysUtils, Classes, Graphics, Controls, Forms, Dialogs,
  ComCtrls;

{ Used in - GrpPro - Group and program parameteres
          - VerPro - Version information for single file
          - Brw    - Memory information }

Type
  TParamDialog = class(TForm)
    ListView: TListView;
    procedure FormKeyDown (Sender: TObject; var Key: Word; Shift: TShiftState);

  private
    def: boolean;

  public
    Procedure Init (p_title: string);
    Procedure Add (p_name, p_value: string);
    Procedure AddNum (p_name: string; p_value: integer);
    Procedure Run;
  end;

Var
  ParamDialog: TParamDialog;

IMPLEMENTATION

{$R *.DFM}

(**************************************************************************)

Procedure TParamDialog.FormKeyDown (Sender: TObject;
                                   var Key: Word;
                                   Shift: TShiftState);
Begin
     if (key = VK_ESCAPE) and (Shift = []) then Close;
End;

Procedure TParamDialog.Init (p_title: string);
Begin
     Caption := p_title;
     ListView.Items.BeginUpdate;
     ListView.Items.Clear;
End;

Procedure TParamDialog.Add (p_name, p_value: string);
Var  ref:  TListItem;
Begin
     ref := ListView.Items.Add;
     ref.Caption := p_name;
     ref.SubItems.Add (p_value);
End;

Procedure TParamDialog.AddNum (p_name: string; p_value: integer);
Var  t: string [16];
Begin
     str (p_value:9, t);
     t := copy (t, 1, 3) + ' ' + copy (t, 4, 3) + ' ' + copy (t, 7, 3);
     Add (p_name, t);
End;

Procedure TParamDialog.Run;
Var  form: TForm;
Begin
     ListView.Items.EndUpdate;

     if not def then begin
        form := Application.MainForm;
        Top := form.Top + (form.Height - Height) div 2;
        Left := form.Left + (form.Width - Width) div 2;
        def := true;
     end;

     WindowState := wsNormal;
     Show;
End;

END.
