UNIT StopDlg;

INTERFACE

Uses
  Windows, Messages, SysUtils, Classes, Graphics,
  Controls, Forms, Dialogs, StdCtrls, ExtCtrls;

Type
  TStopDialog = class (TForm)
    TopPanel: TPanel;
    InfoLabel1: TLabel;
    InfoLabel2: TLabel;
    InfoLabel3: TLabel;
    CancelButton: TButton;
    procedure CancelButtonClick (Sender: TObject);
    procedure FormResize (Sender: TObject);
  end;

Var StopDialog: TStopDialog;

{--------------------------------------------------------------------------}

Var StopFlag: boolean;
    StopCount: integer = 0;

Procedure StopOpen (title: string);
Procedure StopClose;

Procedure StopTest;
Procedure StopInfo (txt: string);
Procedure StopInfo2 (txt1, txt2: string);

{--------------------------------------------------------------------------}

Procedure BeginWait (txt: string);
Procedure EndWait;

IMPLEMENTATION

{$R *.DFM}

Uses Brw; { Browser }

(********************************* TIMER **********************************)

Var timer_count: integer = 0;
    start_ticks: longword;

Procedure StartTime;
Begin
     inc (timer_count);
     if timer_count = 1 then
        start_ticks := GetTickCount;
End;

Procedure StopTime;
Var  stop_ticks: longword;
Begin
     if timer_count = 1 then begin
        stop_ticks := GetTickCount;
        Browser.Status (IntToStr (stop_ticks - start_ticks) + ' ms');
     end;

     dec (timer_count);
End;

(****************************** STOP DIALOG *******************************)

Const limit = 200; { ms }
Var   last:  integer;
      empty: boolean;
      stop_count: integer = 0;

Procedure TStopDialog.FormResize (Sender: TObject);
Begin
     CancelButton.Left := (ClientWidth - CancelButton.Width) div 2;
End;

Procedure TStopDialog.CancelButtonClick (Sender: TObject);
Begin
     StopFlag := true;
     CancelButton.Enabled := false;
End;

(****************************** OPEN / CLOSE ******************************)

Procedure StopOpen (title: string);
Var  form: TForm;
Begin
     inc (stop_count);
     if stop_count = 1 then begin

        StopFlag := false;
        last := GetTickCount - limit;
        empty := true;

        form := Application.MainForm;
        form.Enabled := false;
        // Browser.SetControls (false);

        with StopDialog do begin
           Caption := title;
           InfoLabel1.Caption := '';
           InfoLabel2.Caption := '';
           InfoLabel3.Caption := '';
           CancelButton.Enabled := true;

           Top := form.Top + (form.Height - Height) div 2;
           Left := form.Left + (form.Width - Width) div 2;
        end;

        StopDialog.Show;
        StartTime;

     end;
End;

Procedure StopClose;
Begin
     if stop_count = 1 then begin
        StopTime;
        StopDialog.Hide;
        Application.MainForm.Enabled := true;
        // Browser.SetControls (true);
     end;
     dec (stop_count);
End;

(****************************** TEST / INFO *******************************)

Procedure StopTest;
Var  time: integer;
Begin
     time := GetTickCount;
     if (time > last+limit) or (time < last) then begin
        last := time;
        Application.ProcessMessages;
     end;
End;

Procedure StopInfo3 (txt1, txt2, txt3: string);
Var  time: integer;
Begin
     time := GetTickCount;
     if (time > last+limit) or (time < last) then begin
        StopDialog.InfoLabel1.Caption := txt1;
        StopDialog.InfoLabel2.Caption := txt2;
        StopDialog.InfoLabel3.Caption := txt3;
     end;

     if empty then begin
        { prvni text se ihned zobrazi }
        StopDialog.Update;
        empty := false;
     end;

     StopTest;
End;

Procedure StopInfo2 (txt1, txt2: string);
Begin
     StopInfo3 (txt1, 'and', txt2);
End;

Procedure StopInfo (txt: string);
Begin
     StopInfo3 (txt, '', '');
End;

(************************* BEGIN WAIT / END WAIT **************************)

Var  wait_count: integer = 0;

Procedure BeginWait (txt: string);
Begin
     inc (wait_count);
     if wait_count = 1 then begin
        Screen.Cursor := crHourglass;
        Browser.Status (txt);
        StartTime;
     end;
End;

Procedure EndWait;
Begin
     if wait_count = 1 then begin
        StopTime;
        // Browser.Status ('');
        Screen.Cursor := crDefault;
     end;
     dec (wait_count);
End;

END.
