UNIT TextPro;

INTERFACE

Uses SysUtils, Classes,
     BinIO, ItemPro;

(******************************* TEXT ITEM ********************************)

Type TTextItem = class (TItem)
        value: string;

        constructor CreateFolder (p_name: string);
        constructor CreateItem (p_name, p_value: string); 

        procedure ShowItem (var txt: TColumns); override;
        function  GetSortSet: TSortSet; override;
        function  GetHeader: TBrwHeader; override;

        procedure Dupl (item: TItem); override;
        function  IsEqual (item: TItem): boolean; override;

        procedure Load (f: TBinRead; v: integer); override;
        procedure Save (f: TBinWrite; v: integer); override;
     end;

IMPLEMENTATION

(******************************* TEXT ITEM ********************************)

Constructor TTextItem.CreateFolder (p_name: string);
Begin
     inherited Create;

     name   := p_name;
     folder := true;
End;

Constructor TTextItem.CreateItem (p_name, p_value: string);
Begin
     inherited Create;

     name  := p_name;
     value := p_value;
End;

(******************************* SHOW ITEMS *******************************)

Procedure TTextItem.ShowItem (var txt: TColumns);
Begin
     txt[1] := name;
     txt[2] := value;
End;

(******************************* SORT ITEMS *******************************)

Function TTextItem.GetSortSet: TSortSet;
Begin
     result := [ByValue];
End;

(********************************* HEADER *********************************)

Var TextHeader: TBrwHeader = nil;

Procedure CreateTextHeader;
Begin
     TextHeader := TBrwHeader.Create;
     with TextHeader do begin
        Add ('Name', 100, ByName);
        Add ('Value', 100, ByValue);
     end;
End;

Function TTextItem.GetHeader: TBrwHeader;
Begin
     if TextHeader = nil then CreateTextHeader;
     result := TextHeader;
End;

(******************************** COMPARE *********************************)

Procedure TTextItem.Dupl (item: TItem);
Var  p: TTextItem;
Begin
     inherited;
     p := item as TTextItem;
     value := p.value;
End;

Function TTextItem.IsEqual (item: TItem): boolean;
Var  p:  TTextItem;
Begin
     p := item as TTextItem;
     result := (value = p.value);
End;

(****************************** LOAD / SAVE *******************************)

Procedure TTextItem.Load (f: TBinRead; v: integer);
Begin
     inherited;
     f.ReadStr (Value);
End;

Procedure TTextItem.Save (f: TBInWrite; v: integer);
Begin
     inherited;
     f.WriteStr (Value);
End;

END.

